package com.hzs.common.core.enums;

import com.hzs.common.core.constant.EnumsPrefixConstants;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * 订单类型枚举类
 *
 * @author hzs
 */
@AllArgsConstructor
@Getter
public enum EOrderType {

    /**
     * 报单订单
     */
    REGISTER_ORDER(1, "报单订单", 0, EnumsPrefixConstants.ORDER_TYPE + 1),

    /**
     * 消费订单
     */
    UPGRADE_ORDER(2, "消费订单", 0, EnumsPrefixConstants.ORDER_TYPE + 2),

    /**
     * 复消订单，用积分兑换商品
     */
    RESALE_ORDER(30, "复消订单", 0, EnumsPrefixConstants.ORDER_TYPE + 30),

    /**
     * 复消积分订单
     * 2024.07.18 需求调整，后续此专区会被废弃掉
     */
    RESALE_INTEGRAL_ORDER(31, "复消积分订单", 0, EnumsPrefixConstants.ORDER_TYPE + 31),

    /**
     * 年包专区
     */
    RENEWAL_ORDER(33, "年包订单", 0, EnumsPrefixConstants.ORDER_TYPE + 33),

    /**
     * 虚拟订单（添加店铺时，根据PV生成虚拟订单）
     */
    FICTITIOUS_ORDER(20, "虚拟订单", 0, EnumsPrefixConstants.ORDER_TYPE + 20),

    //////////////////// 暂不用类型 ////////////////////

    /**
     * 复购订单 -- 暂不用
     */
    REPURCHASE_ORDER(3, "复购订单", 1, EnumsPrefixConstants.ORDER_TYPE + 3),
    /**
     * 提货订单 -- 暂不用
     */
    PICK_ORDER(8, "提货订单", 1, EnumsPrefixConstants.ORDER_TYPE + 8),
    /**
     * 兑换订单 -- 暂不用
     */
    EXCHANGE_ORDER(11, "兑换订单", 1, EnumsPrefixConstants.ORDER_TYPE + 11),
    /**
     * 二次发货订单 -- 暂不用
     */
    SECOND_ORDER(23, "二次发货", 1, EnumsPrefixConstants.ORDER_TYPE + 23),

    ;

    /**
     * 实际值
     */
    private final int value;
    /**
     * 显示标签
     */
    private final String label;
    /**
     * 是否启用（0=是,1=否） -- 来源EYesNo
     */
    private final int enable;
    /**
     * 国际化翻译key值
     */
    private final String key;

    /**
     * 根据值，返回枚举
     *
     * @param value
     * @return
     */
    public static EOrderType getEnumByValue(int value) {
        for (EOrderType eOrderType : EOrderType.values()) {
            if (eOrderType.getValue() == value) {
                return eOrderType;
            }
        }
        return null;
    }

    public static List<EOrderType> getOrderTypeSpecial() {
        List<EOrderType> resultList = new ArrayList<>();
        resultList.add(EOrderType.REGISTER_ORDER);
        resultList.add(EOrderType.UPGRADE_ORDER);
        resultList.add(EOrderType.REPURCHASE_ORDER);
        return resultList;
    }

}
